#line 423 "nws/color.nw"
#ifndef _NKLEIN_COLOR_H_
#define _NKLEIN_COLOR_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "expr.h"

#line 399 "nws/color.nw"
class color {
protected:
    
#line 65 "nws/color.nw"
const scene* myScene;
#line 71 "nws/color.nw"
basevec< expr* > channels;
#line 77 "nws/color.nw"
typedef std::map< std::string, class portal* > PortalMap;
PortalMap portals;
#line 84 "nws/color.nw"
double specularness;
double transparency;
double reflectiveness;
double phong;
double indexOfRefraction;
#line 98 "nws/color.nw"
bool usesPosition;
bool usesNormal;
bool usesDirection;
#line 107 "nws/color.nw"
mathvec< double > scale;
basevec< mathvec< double > > orientation;
mathvec< double > center;
#line 402 "nws/color.nw"
public:
    
#line 123 "nws/color.nw"
color( const scene* ss );
#line 135 "nws/color.nw"
color( const char* str, const scene* ss = 0 );
#line 155 "nws/color.nw"
void setDimensions( unsigned int dd );
#line 178 "nws/color.nw"
inline unsigned int getChannelCount( void ) const {
    return this->channels.size();
};
#line 186 "nws/color.nw"
inline double getReflectiveness( void ) const {
    return this->reflectiveness;
};
inline double getTransparency( void ) const {
    return this->transparency;
};
inline double getIndexOfRefraction( void ) const {
    return this->indexOfRefraction;
};
inline double getSpecularness( void ) const {
    return this->specularness;
};
inline double getPhong( void ) const {
    return this->phong;
};
#line 206 "nws/color.nw"
void evaluate(
    const mathvec< double >& position,
    const mathvec< double >& normal,
    const mathvec< double >& direction,
    double contribution, unsigned int height,
    mathvec< double >& pixel
) const;
#line 316 "nws/color.nw"
friend std::istream& operator >> ( std::istream& in, color& cc );
#line 404 "nws/color.nw"
public:
    static const char* id;
};

#line 433 "nws/color.nw"
#endif /*_NKLEIN_COLOR_H_*/
