#line 534 "nws/cylinder.nw"
#ifndef _NKLEIN_CYLINDER_H_
#define _NKLEIN_CYLINDER_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 509 "nws/cylinder.nw"
class cylinder : public object {
protected:
    
#line 48 "nws/cylinder.nw"
unsigned int roundDimensions;
#line 54 "nws/cylinder.nw"
mathvec< double > sphereMask;
#line 512 "nws/cylinder.nw"
    
#line 285 "nws/cylinder.nw"
bool sphereIntersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    double* t1, double* t2
) const;
#line 342 "nws/cylinder.nw"
bool cubeIntersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    double* t1, double* t2,
    mathvec< double >& n1, mathvec< double >& n2
) const;
#line 513 "nws/cylinder.nw"
public:
    
#line 61 "nws/cylinder.nw"
cylinder( const scene* ss );
#line 73 "nws/cylinder.nw"
cylinder( double radius, const scene* ss );
#line 88 "nws/cylinder.nw"
virtual ~cylinder( void );
#line 101 "nws/cylinder.nw"
virtual void setDimensions( unsigned int dd );
#line 136 "nws/cylinder.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 228 "nws/cylinder.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 431 "nws/cylinder.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 469 "nws/cylinder.nw"
friend std::istream& operator >> ( std::istream& in, cylinder& cc );
#line 515 "nws/cylinder.nw"
public:
    static const char* id;
};

#line 544 "nws/cylinder.nw"
#endif /*_NKLEIN_CYLINDER_H_*/
