#line 390 "nws/expr.nw"
#ifndef _NKLEIN_EXPR_H_
#define _NKLEIN_EXPR_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "mathvec.h"

class scene;

    
#line 368 "nws/expr.nw"
class expr {
public:
    
#line 48 "nws/expr.nw"
virtual ~expr( void );
#line 61 "nws/expr.nw"
virtual bool isConstant( void ) const = 0;
virtual bool usesPosition( void ) const = 0;
virtual bool usesNormal( void ) const = 0;
virtual bool usesDirection( void ) const = 0;
#line 72 "nws/expr.nw"
virtual double evaluate(
	const mathvec<double>& position,
	const mathvec<double>& normal,
	const mathvec<double>& direction
    ) = 0;
#line 85 "nws/expr.nw"
virtual std::istream& get(
    std::istream& in,
    const std::map< std::string, class portal* >& portals
) = 0;
#line 94 "nws/expr.nw"
static expr* read(
	std::istream& in,
	const std::map<std::string, class portal*>& portals
    );
static expr* read(
	const char* str,
	const std::map<std::string, class portal*>& portals
    );
#line 261 "nws/expr.nw"
static void read(
    std::istream& in,
    basevec< expr* >& exprs,
    const std::map< std::string, class portal* >& portals
);
static void read(
    const char* str,
    basevec< expr* >& exprs,
    const std::map< std::string, class portal* >& portals
);
#line 371 "nws/expr.nw"
public:
    static const char* id;
};

#line 402 "nws/expr.nw"
#endif /*_NKLEIN_EXPR_H_*/
