#line 264 "nws/image.nw"
#ifndef _NKLEIN_IMAGE_H_
#define _NKLEIN_IMAGE_H_ 1

#include <iostream>
#include <string>
#include "mathvec.h"

    
#line 239 "nws/image.nw"
class image {
protected:
    
#line 43 "nws/image.nw"
unsigned int width;
unsigned int height;
unsigned int depth;
unsigned int channelCount;
#line 52 "nws/image.nw"
std::string basename;
#line 59 "nws/image.nw"
unsigned int currentImage;
#line 242 "nws/image.nw"
    
#line 203 "nws/image.nw"
virtual std::istream& get( std::istream& stream );
#line 243 "nws/image.nw"
public:
    
#line 67 "nws/image.nw"
image( void );
#line 82 "nws/image.nw"
virtual ~image( void );
#line 99 "nws/image.nw"
virtual void setSize(
    unsigned int ww, unsigned int hh,
    unsigned int dd,
    unsigned int cc
);
virtual void setBasename( const std::string& bb );
#line 135 "nws/image.nw"
virtual std::string getNumberedBasename( void );
#line 161 "nws/image.nw"
virtual void add( const mathvec< double >& pixel ) = 0;
virtual void addBorderPixel( void ) = 0;
virtual void addBorderRow( void ) = 0;
#line 171 "nws/image.nw"
static image* read( std::istream& in );
#line 245 "nws/image.nw"
public:
    static const char* id;
};

#line 273 "nws/image.nw"
#endif /*_NKLEIN_IMAGE_H_*/
