#line 187 "nws/input.nw"
#include "input.h"

const char* input::id = "NKVERSION: input( 2.1.2007.03.21 )"; 

#line 20 "nws/input.nw"
input::input( std::istream& _in ) : in( _in ), braceLevel( 0 )
{
}
#line 40 "nws/input.nw"
bool
input::check( bool _ignoreEverything )
{
    unsigned int startBraceLevel = this->braceLevel;

    for (;;) {
	int ch = in.peek();

	if ( ch < 0 ) {
	    break;
	} else if ( ch == '{' ) {
	    this->in.get();
	    ++this->braceLevel;
	} else if ( ch == '}' ) {
	    this->in.get();
	    --this->braceLevel;
	} else if ( ch == ';' ) {
	    if ( this->braceLevel == 0
	    || ( _ignoreEverything && this->braceLevel == startBraceLevel ) ) {
		break;
	    } else {
		this->in.get();
	    }
	} else if ( ch == ',' ) {
	    if ( this->braceLevel == 0 ) {
		break;
	    } else {
		this->in.get();
	    }
	} else if ( ch == '#' ) {
	    while ( ch >= 0 && ch != '\n' ) {
		ch = this->in.get();
	    }
	} else if ( isspace( ch ) ) {
	    this->in.get();
	} else if ( ! _ignoreEverything ) {
	    return true;
	} else {
	    this->in.get();
	}
    }
    return false;
}
#line 94 "nws/input.nw"
void
input::ignore( const char* prefix, const char* token )
{
    char ch;

    std::cerr << prefix << ": Ignoring " << token;
    while ( this->check( true ) ) {
	ch = this->in.get();
#ifndef NDEBUG
	std::cerr << ch;
#endif
    };
    ch = this->in.get();
#ifndef NDEBUG
    std::cerr << ch;
#endif
    std::cerr << std::endl;
}
#line 125 "nws/input.nw"
unsigned int
input::get( char token[], unsigned int tokenLen )
{
    if ( ! this->check() ) {
	return 0;
    }

    unsigned int len = 0;

    int ch = this->in.peek();

    while ( this->in.good() && !isspace( ch )
    && ch != ',' && ch != ';' && ch != '>'
    && len < tokenLen-1 ) {
	ch = this->in.get();
	*token++ = ch;
	++len;
	ch = this->in.peek();
    }

    *token = '\0';

    while ( this->in.good() && !isspace( ch )
    && ch != ',' && ch != ';' && ch != '>' ) {
	ch = this->in.get();
	ch = this->in.peek();
    }

    return len;
}
