#line 261 "nws/intersection.nw"
#include <string>
#include <sstream>
#include <math.h>
#include "input.h"
#include "intersection.h"

const char* intersection::id = "NKVERSION: intersection( 2.1.2007.03.21 )"; 

#line 47 "nws/intersection.nw"
intersection::intersection( void ) : objectColor( 0 )
{
}
#line 142 "nws/intersection.nw"
void
intersection::reorient(
    const mathvec< double >& scale,
    const basevec< mathvec< double > >& orientation,
    const mathvec< double >& center
) {
    this->position *= scale;
    this->position.rotate( orientation );
    this->position += center;

    this->direction *= scale;
    this->direction.rotate( orientation );
    this->direction.normalize();

    this->normal /= scale;
    this->normal.rotate( orientation );
    this->normal.normalize();
}
#line 174 "nws/intersection.nw"
void
intersection::recolor(
    const color& cc
) {
    this->setObjectColor( &cc );
    this->setObjectPosition( this->getPosition() );
    this->setObjectNormal( this->getNormal() );
    this->setObjectDirection( this->getDirection() );
}
#line 197 "nws/intersection.nw"
void
intersection::evaluate(
    double contribution, unsigned int height,
    mathvec< double >& pp
) const {
    if ( this->pixel.size() == 0 ) {
	this->objectColor->evaluate(
	    this->objectPosition, this->objectNormal, this->objectDirection,
	    contribution, height, *(mathvec< double >*)&this->pixel
	);
    }
    pp = this->pixel;
}
