#line 242 "nws/intersection.nw"
#ifndef _NKLEIN_INTERSECTION_H_
#define _NKLEIN_INTERSECTION_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "color.h"

    
#line 218 "nws/intersection.nw"
class intersection {
protected:
    
#line 10 "nws/intersection.nw"
mathvec< double > position;
mathvec< double > normal;
mathvec< double > direction;
bool inside;
#line 21 "nws/intersection.nw"
mathvec< double > objectPosition;
mathvec< double > objectNormal;
mathvec< double > objectDirection;
#line 29 "nws/intersection.nw"
const color* objectColor;
double distance;
#line 36 "nws/intersection.nw"
mathvec< double > pixel;
#line 221 "nws/intersection.nw"
public:
    
#line 43 "nws/intersection.nw"
intersection( void );
#line 58 "nws/intersection.nw"
inline void setPosition( const mathvec< double >& pp ) {
    this->position = pp;
};
inline void setNormal( const mathvec< double >& nn ) {
    this->normal = nn;
};
inline void setDirection( const mathvec< double >& dd ) {
    this->direction = dd;
};
inline void setInside( void ) {
    this->inside = true;
};
inline void setOutside( void ) {
    this->inside = false;
};
inline void setDistance( double dd ) {
    this->distance = dd;
};
#line 84 "nws/intersection.nw"
inline const mathvec< double >& getPosition( void ) const {
    return this->position;
};
inline const mathvec< double >& getNormal( void ) const {
    return this->normal;
};
inline const mathvec< double >& getDirection( void ) const {
    return this->direction;
};
inline bool isInside( void ) const {
    return this->inside;
}
inline bool isOutside( void ) const {
    return ! this->inside;
}
inline const color* getColor( void ) const {
    return this->objectColor;
}
inline double getDistance( void ) const {
    return this->distance;
}
#line 113 "nws/intersection.nw"
inline void setObjectPosition( const mathvec< double >& pp ) {
    this->objectPosition = pp;
};
inline void setObjectNormal( const mathvec< double >& nn ) {
    this->objectNormal = nn;
};
inline void setObjectDirection( const mathvec< double >& dd ) {
    this->objectDirection = dd;
};
inline void setObjectColor( const color* cc ) {
    this->objectColor = cc;
};
#line 134 "nws/intersection.nw"
void reorient(
    const mathvec< double >& scale,
    const basevec< mathvec< double > >& orientation,
    const mathvec< double >& center
);
#line 168 "nws/intersection.nw"
void recolor(
    const color& cc
);
#line 190 "nws/intersection.nw"
void evaluate(
    double contribution, unsigned int height,
    mathvec< double >& pp
) const;
#line 223 "nws/intersection.nw"
public:
    static const char* id;
};

#line 252 "nws/intersection.nw"
#endif /*_NKLEIN_INTERSECTION_H_*/
