#line 259 "nws/light.nw"
#ifndef _NKLEIN_LIGHT_H_
#define _NKLEIN_LIGHT_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "color.h"

    
#line 235 "nws/light.nw"
class light {
protected:
    
#line 37 "nws/light.nw"
const scene* myScene;
#line 44 "nws/light.nw"
mathvec< double > position;
color chroma;
double falloff;
mathvec< double > direction;
double outerCosine;
double cosineRange;
#line 238 "nws/light.nw"
public:
    
#line 59 "nws/light.nw"
light( const scene* ss );
#line 77 "nws/light.nw"
void setDimensions( unsigned int dd );
#line 101 "nws/light.nw"
inline const mathvec< double >& getPosition( void ) const {
    return this->position;
};
#line 110 "nws/light.nw"
inline double getFallOff( void ) const {
    return this->falloff;
};
#line 121 "nws/light.nw"
void evaluate(
    const mathvec< double >& position,
    const mathvec< double >& normal,
    const mathvec< double >& direction,
    double contribution, unsigned int height,
    mathvec< double >& pixel
) const;
#line 162 "nws/light.nw"
friend std::istream& operator >> ( std::istream& in, light& cc );
#line 240 "nws/light.nw"
public:
    static const char* id;
};

#line 269 "nws/light.nw"
#endif /*_NKLEIN_LIGHT_H_*/
