#line 260 "nws/nkthread.nw"
#ifndef _NKLEIN_THREAD_H_
#define _NKLEIN_THREAD_H_ 1

#include <deque>

#ifdef USE_PTHREADS
#  include <pthread.h>
#endif

#line 230 "nws/nkthread.nw"
class thread {
public:
#line 119 "nws/thread-work.nw"
class work {
protected:
#line 10 "nws/thread-work.nw"
#ifdef USE_PTHREADS
pthread_mutex_t mutex;
pthread_cond_t condition;
#endif
bool done;
#line 122 "nws/thread-work.nw"
public:
    
#line 21 "nws/thread-work.nw"
work( void );
#line 38 "nws/thread-work.nw"
virtual ~work( void );
#line 56 "nws/thread-work.nw"
virtual void perform( void ) = 0;
#line 61 "nws/thread-work.nw"
void start( void );
#line 76 "nws/thread-work.nw"
void wait( void );
#line 96 "nws/thread-work.nw"
void finish( void );
#line 124 "nws/thread-work.nw"
public:
    static const char* id;
};
#line 181 "nws/thread-worker.nw"
class worker {
protected:
#line 9 "nws/thread-worker.nw"
#ifdef USE_PTHREADS
pthread_mutex_t mutex;
pthread_cond_t condition;
pthread_t myThread;
#endif
#line 18 "nws/thread-worker.nw"
thread::work* todo;
bool done;
#line 184 "nws/thread-worker.nw"
public:
    
#line 27 "nws/thread-worker.nw"
worker( void );
#line 46 "nws/thread-worker.nw"
virtual ~worker( void );
#line 69 "nws/thread-worker.nw"
void setWork( thread::work* ww ) {
    this->todo = ww;
};
#line 78 "nws/thread-worker.nw"
void wakeup( void );
#line 92 "nws/thread-worker.nw"
void lock( void );
void wait( void );
void unlock( void );
#line 143 "nws/thread-worker.nw"
void* loop( void );
#line 186 "nws/thread-worker.nw"
public:
    static const char* id;
};
#line 234 "nws/nkthread.nw"
protected:
    
#line 28 "nws/nkthread.nw"
#ifdef USE_PTHREADS
pthread_mutex_t mutex;
#endif
std::deque< worker* > workers;
#line 236 "nws/nkthread.nw"
public:
    
#line 37 "nws/nkthread.nw"
static thread* instance( void );
#line 51 "nws/nkthread.nw"
thread( void );
#line 67 "nws/nkthread.nw"
~thread( void );
#line 88 "nws/nkthread.nw"
void setWorkerCount( unsigned int nn );
#line 148 "nws/nkthread.nw"
void start( thread::work* ww );
#line 181 "nws/nkthread.nw"
void lock( void );
void unlock( void );
#line 211 "nws/nkthread.nw"
void wait( void* cond );
#line 238 "nws/nkthread.nw"
    friend class thread::worker;
protected:
    
#line 128 "nws/nkthread.nw"
void makeWorkerAvailable( worker* ww );
#line 241 "nws/nkthread.nw"
public:
    static const char* id;
};

#line 271 "nws/nkthread.nw"
#endif /*_NKLEIN_THREAD_H_*/
