#line 376 "nws/object.nw"
#ifndef _NKLEIN_OBJECT_H_
#define _NKLEIN_OBJECT_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "intersection.h"

    
#line 350 "nws/object.nw"
class object {
protected:
    
#line 33 "nws/object.nw"
const scene* myScene;
#line 40 "nws/object.nw"
double defaultScale;
mathvec< double > scale;
basevec< mathvec< double > > orientation;
mathvec< double > center;
color chroma;
bool gotColor;
#line 52 "nws/object.nw"
static color fakeColor;
#line 353 "nws/object.nw"
protected:
    
#line 226 "nws/object.nw"
void forgeHit(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 355 "nws/object.nw"
public:
    
#line 68 "nws/object.nw"
object( const scene* ss );
#line 83 "nws/object.nw"
virtual ~object( void );
#line 97 "nws/object.nw"
virtual void setDimensions( unsigned int dd );
#line 115 "nws/object.nw"
inline const mathvec< double >& getScale( void ) const {
    return this->scale;
};
inline const basevec< mathvec< double > >& getOrientation( void ) const {
    return this->orientation;
};
inline const mathvec< double >& getCenter( void ) const {
    return this->center;
};
inline const color& getColor( void ) const {
    return this->chroma;
};
inline color* getColorPtr( void ) {
    return &this->chroma;
};
#line 136 "nws/object.nw"
inline void setScale( const mathvec< double >& ss ) {
    this->scale = ss;
};
inline void setOrientation( const basevec< mathvec< double > >& oo ) {
    this->orientation = oo;
};
inline void setCenter( const mathvec< double >& cc ) {
    this->center = cc;
};
#line 154 "nws/object.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const = 0;
#line 167 "nws/object.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const = 0;
#line 182 "nws/object.nw"
virtual bool inside( const mathvec< double >& start ) const = 0;
virtual bool _inside( const mathvec< double >& start ) const = 0;
#line 192 "nws/object.nw"
void evaluate(
    const mathvec< double >& position,
    const mathvec< double >& normal,
    const mathvec< double >& direction,
    double contribution, unsigned int height,
    mathvec< double >& pixel
) const;
#line 266 "nws/object.nw"
friend std::istream& operator >> ( std::istream& in, object& cc );
#line 313 "nws/object.nw"
static object* read( std::istream& in, const scene* ss );
#line 357 "nws/object.nw"
public:
    static const char* id;
};

#line 386 "nws/object.nw"
#endif /*_NKLEIN_OBJECT_H_*/
