#line 282 "nws/portal.nw"
#ifndef _NKLEIN_PORTAL_H_
#define _NKLEIN_PORTAL_H_ 1

#include <iostream>
#include <string>
#include "mathvec.h"

class scene;
class universe;

    
#line 257 "nws/portal.nw"
class portal {
protected:
    
#line 34 "nws/portal.nw"
const scene* myScene;
#line 41 "nws/portal.nw"
const universe* univ;
std::string universeName;
#line 47 "nws/portal.nw"
mathvec< double > pixel;
#line 53 "nws/portal.nw"
mathvec< double > scale;
basevec< mathvec< double > > orientation;
mathvec< double > center;
#line 260 "nws/portal.nw"
public:
    
#line 63 "nws/portal.nw"
portal( const scene* ss );
#line 76 "nws/portal.nw"
~portal( void );
#line 91 "nws/portal.nw"
const mathvec< double >&  getPixel( void ) const {
    return this->pixel;
};
#line 107 "nws/portal.nw"
void setDimensions( unsigned int dd );
#line 128 "nws/portal.nw"
bool evaluate(
    const mathvec< double >& position,
    const mathvec< double >& direction,
    double contribution, unsigned int height, unsigned int channelCount
);
#line 209 "nws/portal.nw"
friend std::istream& operator >> ( std::istream& in, portal& pp );
#line 262 "nws/portal.nw"
public:
    static const char* id;
};

#line 294 "nws/portal.nw"
#endif /*_NKLEIN_PORTAL_H_*/
