#line 235 "nws/scene.nw"
#include "input.h"
#include "scene.h"

const char* scene::id = "NKVERSION: scene( 2.1.2007.03.21 )"; 

#line 52 "nws/scene.nw"
scene::scene( void )
{
}
#line 69 "nws/scene.nw"
scene::~scene( void )
{
    UniverseMap::iterator uu;
    for ( uu=this->universes.begin(); uu != this->universes.end(); ++uu ) {
	delete uu->second;
    }
    ViewList::iterator vv;
    for ( vv=this->views.begin(); vv != this->views.end(); ++vv ) {
	delete *vv;
    }
}
#line 107 "nws/scene.nw"
void
scene::render( void ) const
{
    ViewList::const_iterator vv;
    for ( vv=this->views.begin(); vv != this->views.end(); ++vv ) {
	(*vv)->render();
    }
}
#line 134 "nws/scene.nw"
std::istream&
operator >> ( std::istream& stream, scene& ss )
{
    input in( stream );

    while ( in.check() ) {
	char token[ input::MAX_TOKEN_LEN ];

	if ( in.get( token, sizeof(token) ) == 0 ) {
	    return stream;
	}

	std::string tok( token );
	char semicolon;

	if ( tok == "view" ) {
	    
#line 166 "nws/scene.nw"
view* vv = new view( (const scene*)&ss );
stream >> *vv >> semicolon;
ss.views.insert( ss.views.end(), vv );
#line 151 "nws/scene.nw"
	} else if ( tok == "universe" ) {
	    
#line 176 "nws/scene.nw"
if ( in.get( token, sizeof(token) ) == 0 ) {
    return stream;
}
std::string name( token );
universe* uu = new universe( (const scene*)&ss );
stream >> *uu >> semicolon;
ss.universes[ name ] = uu;
#line 153 "nws/scene.nw"
	} else {
	    in.ignore( "SCENE", tok.c_str() );
	}
    }

    return stream;
}
