#line 215 "nws/scene.nw"
#ifndef _NKLEIN_SCENE_H_
#define _NKLEIN_SCENE_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "view.h"
#include "universe.h"

    
#line 191 "nws/scene.nw"
class scene {
protected:
    
#line 38 "nws/scene.nw"
typedef std::vector< const view* > ViewList;
ViewList views;
typedef std::map< std::string, const universe* > UniverseMap;
UniverseMap universes;
#line 194 "nws/scene.nw"
public:
    
#line 48 "nws/scene.nw"
scene( void );
#line 61 "nws/scene.nw"
~scene( void );
#line 87 "nws/scene.nw"
const universe* getUniverse( const std::string& name ) const {
    UniverseMap::const_iterator uu = this->universes.find( name );
    if ( uu != this->universes.end() ) {
	return uu->second;
    } else {
	return 0;
    }
};
#line 101 "nws/scene.nw"
void render( void ) const;
#line 128 "nws/scene.nw"
friend std::istream& operator >> ( std::istream& in, scene& ss );
#line 196 "nws/scene.nw"
public:
    static const char* id;
};

#line 226 "nws/scene.nw"
#endif /*_NKLEIN_SCENE_H_*/
