#line 542 "nws/universe.nw"
#ifndef _NKLEIN_UNIVERSE_H_
#define _NKLEIN_UNIVERSE_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "light.h"
#include "object.h"

    
#line 518 "nws/universe.nw"
class universe {
protected:
    
#line 48 "nws/universe.nw"
const scene* myScene;
#line 55 "nws/universe.nw"
unsigned int dimensions;
std::vector< light* > lights;
std::vector< object* > objects;
color ambientLight;
bool gotAmbient;
color skyColor;
bool quickRender;
#line 521 "nws/universe.nw"
public:
    
#line 71 "nws/universe.nw"
universe( const scene* ss );
#line 86 "nws/universe.nw"
~universe( void );
#line 109 "nws/universe.nw"
inline unsigned int getDimensions( void ) const {
    return this->dimensions;
};
#line 119 "nws/universe.nw"
void setDimensions( unsigned int dims );
#line 144 "nws/universe.nw"
bool evaluate(
    const mathvec< double >& position,
    const mathvec< double >& direction,
    double contribution, unsigned int height,
    mathvec< double >& pixel
) const;
#line 174 "nws/universe.nw"
bool evaluate(
    const mathvec< double >& position,
    const mathvec< double >& direction,
    double indexOfRefraction,
    double contribution, unsigned int height,
    mathvec< double >& pixel
) const;
#line 379 "nws/universe.nw"
void checkShadow(
    const mathvec< double >& position,
    const mathvec< double >& direction,
    double lampDistance,
    double contribution, unsigned int height,
    double& amount,
    mathvec< double >& pixel
) const;
#line 447 "nws/universe.nw"
friend std::istream& operator >> ( std::istream& in, universe& cc );
#line 523 "nws/universe.nw"
public:
    static const char* id;
};

#line 553 "nws/universe.nw"
#endif /*_NKLEIN_UNIVERSE_H_*/
