#line 770 "nws/view.nw"
#ifndef _NKLEIN_VIEW_H_
#define _NKLEIN_VIEW_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "color.h"
#include "image.h"

    
#line 746 "nws/view.nw"
class view {
protected:
    
#line 167 "nws/view.nw"
const scene* myScene;
#line 175 "nws/view.nw"
color viewport;
#line 184 "nws/view.nw"
mathvec< unsigned int > size;
mathvec< double > angularExtents;
bool wrap;
double gamma;
unsigned int border;
#line 194 "nws/view.nw"
unsigned int composite;
#line 199 "nws/view.nw"
unsigned int traceDepth;
#line 206 "nws/view.nw"
mathvec<unsigned int> permutation;
std::vector<bool> contributesToWidth;
std::vector<bool> needsBorders;
bool vertical;
#line 214 "nws/view.nw"
std::vector< image* > images;
#line 749 "nws/view.nw"
public:
    
#line 226 "nws/view.nw"
view( const scene* ss );
#line 241 "nws/view.nw"
~view( void );
#line 257 "nws/view.nw"
void render( void ) const;
#line 403 "nws/view.nw"
bool calculateDirection(
    const mathvec< unsigned int >& coordinates,
    mathvec< double >& direction
) const;
#line 497 "nws/view.nw"
void incrementDirection( mathvec< unsigned int >& coordinates ) const;
#line 525 "nws/view.nw"
friend std::istream& operator >> ( std::istream& in, view& cc );
#line 751 "nws/view.nw"
public:
    static const char* id;
};

#line 781 "nws/view.nw"
#endif /*_NKLEIN_VIEW_H_*/
